;===============================================================================
;
; sword tech ready stance 2.0
;
; - speed up the sword tech gauge
; - for sword tech command, setup wait time based on selected sword tech
;
;===============================================================================

header
hirom

;===============================================================================
;
; setup swordt tech gauge speed
;
;===============================================================================
org     $C17D84
gauge_speed:

        LDA $7B82               ;load swordtech gauge
        CLC                     ;clear carry
        ADC #$02                ;add to gauge speed
        STA $7B82               ;update it
        JMP $7D90               ;optimized NOP
        
warnpc  $C17D90

;===============================================================================
;
; link for setup of wait time
;
;===============================================================================
org     $C203F4
time_setup_link:

        JSL time_setup          ;setup command time
        LDA $EE                 ;get time
        NOP

warnpc  $C203FB

;===============================================================================
;
; setup time for command
;
;===============================================================================
org     $C3F600                 ;(*) change for the start of free space

;-------------------------------------------------------------------------------
; time table for sword tech
;-------------------------------------------------------------------------------
sword_tech_time:

    db #$20                     ;dispatch
    db #$40                     ;retort
    db #$60                     ;slash
    db #$80                     ;quadra slam
    db #$A0                     ;empowerer
    db #$C0                     ;stunner
    db #$E0                     ;quadra slice
    db #$FF                     ;cleave

;-------------------------------------------------------------------------------
; time setup
;-------------------------------------------------------------------------------
time_setup:

    ;init
        PHX                     ;backup X
        LDA $3A7B               ;command sub-index
        PHA                     ;$02,S is command sub-index
        LDA $3A7A               ;command id
        PHA                     ;$01,S is command identifier

    ;setup default time to wait
        TAX                     ;to use command id as index
        LDA $C2067B,X           ;get default time to wait for command
        STA $EE                 ;setup time

    ;check if sword tech
        LDA $01,S               ;command id
        CMP #$07                ;sword tech command
        BNE .exit               ;exit if not sword tech

    ;check sub-index
        LDA $02,S               ;command sub-index
        CMP #$55                ;1st sword tech action in general actions
        BCC .exit               ;exit if unvalid
        CMP #$5D                ;8th sword tech action in general actions plus one
        BCS .exit               ;exit if unvalid

    ;adjust sub-index
        SEC                     ;set carry
        SBC #$55                ;1st sword tech action

    ;setup time
        TAX                     ;setup move index
        LDA.L sword_tech_time,X ;get time for sword tech
        STA $EE                 ;save it

    ;exit
    .exit
        PLA
        PLA
        PLX
        RTL

;-------------------------------------------------------------------------------
; end of block
;-------------------------------------------------------------------------------
warnpc  $C3F636                 ;(*) change for the end of free space
